studentdb/config/routes.rb
Rails.application.routes.draw do
  resources :projects do
    resources :students
  end

  root "projects#index"
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

studentdb/app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

studentdb/app/models/project.rb
class Project < ApplicationRecord
  has_many :students
end

studentdb/app/models/student.rb
class Student < ApplicationRecord
  belongs_to :project
end

studentdb/app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

studentdb/app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: %i[ show edit update destroy ]
  http_basic_authenticate_with name: "admin", password: "admin", except: :index

  # GET /projects or /projects.json
  def index
    @projects = Project.all
    respond_to do |format|
      format.html
      format.json { render json: @projects }
      format.xml { render xml: @projects }
    end
  end

  # GET /projects/1 or /projects/1.json
  def show
  end

  # GET /projects/new
  def new
    @project = Project.new
  end

  # GET /projects/1/edit
  def edit
  end

  # POST /projects or /projects.json
  def create
    @project = Project.new(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to @project, notice: "Project was successfully created." }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /projects/1 or /projects/1.json
  def update
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to @project, notice: "Project was successfully updated." }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1 or /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: "Project was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def project_params
      params.require(:project).permit(:name, :url)
    end
end

studentdb/app/controllers/students_controller.rb
class StudentsController < ApplicationController
  before_action :set_project

  def create
    @student = @project.students.new(student_params)
    respond_to do |format|
      if @student.save
        format.html { redirect_to @project, notice: 'Student was successfully created.' }
      end
    end
  end
  private
  def set_project
    @project = Project.find(params[:project_id])
  end
  def student_params
    params.require(:student).permit(:studentid, :name)
  end
end

studentdb/app/helpers/application_helper.rb
module ApplicationHelper
end

studentdb/app/helpers/projects_helper.rb
module ProjectsHelper
end

studentdb/app/helpers/students_helper.rb
module StudentsHelper
end

studentdb/app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Studentdb</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

studentdb/app/views/projects/_form.html.erb
<%= form_with(model: project) do |form| %>
  <% if project.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
        <% project.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name %>
  </div>

  <div class="field">
    <%= form.label :url %>
    <%= form.text_field :url %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

studentdb/app/views/projects/edit.html.erb
<h1>Editing Project</h1>

<%= render 'form', project: @project %>

<%= link_to 'Show', @project %> |
<%= link_to 'Back', projects_path %>

studentdb/app/views/projects/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Projects</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Url</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @projects.each do |project| %>
      <tr>
        <td><%= project.name %></td>
        <td><%= project.url %></td>
        <td><%= link_to 'Show', project %></td>
        <td><%= link_to 'Edit', edit_project_path(project) %></td>
        <td><%= link_to 'Destroy', project, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Project', new_project_path %>

studentdb/app/views/projects/new.html.erb
<h1>New Project</h1>

<%= render 'form', project: @project %>

<%= link_to 'Back', projects_path %>

studentdb/app/views/projects/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @project.name %>
</p>

<p>
  <strong>Url:</strong>
  <%= @project.url %>
</p>

<h2>Students</h2>
<table>
  <thead>
  <tr>
    <th>Student ID </th>
    <th>Name</th>
  </tr>
  </thead>
  <tbody>
  <% @project.students.each do |student| %>
    <tr>
      <td><%= student.studentid %></td>
      <td><%= student.name %></td>
    </tr>
  <% end %>
  </tbody>
</table>
<br/>
<h2>Add a student:</h2>
<%= form_for([@project, @project.students.build]) do |f| %>
  <div class="field">
    <%= f.label :studentid %><br />
    <%= f.text_field :studentid %>
  </div>
  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>
<br />

<%= link_to 'Edit', edit_project_path(@project) %> |
<%= link_to 'Back', projects_path %>